#include <iostream>
#include "vec3.h"

void Vec3::printf() const {
    std::cout << "x:" << x << " y:" << y << " z:" << z << std::endl; // Il << è un flush operator, manda le cose dentro il cout (stdout); il :: indica il membro statico della classe
}

Scalar dot(const Vec3 &a, const Vec3 &b) {
    return a.x * b.x + a.y * b.y + a.z * b.z;
}

Vec3 cross(const Vec3 &a, const Vec3 &b) {
    return Vec3(
        a.y * b.z - a.z * b.y,
        a.z * b.x - a.x * b.z,
        a.x * b.y - a.y * b.x
    );
}

Scalar degrees_between(const Vec3 &a, const Vec3 &b) {
    Scalar cosineTimesLengths = dot(a, b);
    Scalar sineTimesLengths = cross(a, b).length();

    return to_deg(std::atan2(sineTimesLengths, cosineTimesLengths));
}
